Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2323 by niro, Fri Jan 3 13:19:11 2014 UTC revision 2404 by niro, Tue Jan 7 13:20:20 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  #images: (get ${CDIMAGENAME})  # ignore the environment
11  source /mnt/cdrom/system/images.conf  LC_ALL=C
12    # include dir
13    INSTALLER_LIBDIR="%LIBDIR%"
14    
15  #Includes  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16  source /usr/lib/installer/functions/findhdd.sh > /dev/null  # -> now in images.conf
17  ### bugfix ###############################  CURRENTLINE=0
 cdromdev="$(echo ${cdromdev} | sed 's/ //')"  
 ########################################  
18    
19  ### System/Config Version  die()
20  VERSION="%VERSIONTAG%"  {
21  TITLE="Installer - ${VERSION}"   echo "Error: $@"
22     exit 1
23    }
24    
25  CDPATH="/mnt/cdrom"  # load common includes
26  INSTALLPATH="/mnt/magellan"  for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31    do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41    # -> now in images.conf
42    CDIMAGENAME=""
43    TOTALLINES=""
44  CURRENTLINE=0  CURRENTLINE=0
45  #TOTALLINES=11072 # -> now in images.conf  if [ -e /mnt/cdrom/system/images.conf ]
46    then
47     source /mnt/cdrom/system/images.conf
48     # check if all required variables are set
49     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
50     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
51    else
52     die "/mnt/cdrom/system/images.conf not found"
53    fi
54    
55  # standard kernel opts  ### System/Config Version
56  KERNELOPTS="quiet video=1024x768"  VERSION="%VERSIONTAG%"
57    TITLE="${DEFAULT_TITLE} - ${VERSION}"
58    
59  # grub options  # some sane defaults
60    CDROOT="${DEFAULT_CDROOT}"
61    INSTALLROOT="${DEFAULT_INSTALLROOT}"
62    KERNELPKG="${DEFAULT_KERNELPKG}"
63    KERNELOPTS="${DEFAULT_KERNELOPTS}"
64  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
65  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
66  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
67  SPECIALDEVICE=""  SPECIALDEVICE=""
68  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
69    FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
 # target filesystem  
 FORMAT_FILESYSTEM="ext4"  
70    
71  #################################################  #################################################
72  #  DIALOG BOXEN #  #  DIALOG BOXEN #
73  #################################################  #################################################
74    
75  die()  dialog_die()
76  {  {
77   ERROR=$1   ERROR="$1"
78   RETVAL=$?   RETVAL="$?"
79   dialog_install_failure   dialog_install_failure
80   exit 1   exit 1
81  }  }
82    
83  dialog_warning()  dialog_warning()
84  {  {
85   dialog \   local retval
86   --backtitle "${TITLE}" \  
87   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
88   --defaultno \   retval=$?
89   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
90   then   then
91   clear   clear
92   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
93   exit 1   exit 1
94   fi   fi
95  }  }
96    
97  dialog_setup_hdd_info()  dialog_setup_hdd_info()
98  {  {
  local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
99   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="$(echo $HDD | sed 's/\/dev\///')"
100    
101   dialog \   dialog \
# Line 133  dialog_setup_system_menu() Line 137  dialog_setup_system_menu()
137   "" "" \   "" "" \
138   "" "\Z1Experten Modi:\Zn" \   "" "\Z1Experten Modi:\Zn" \
139   "2" "Normale IDE-Disk (Manuell)" \   "2" "Normale IDE-Disk (Manuell)" \
  "3" "Flash-Speicher (Manuell)")  
140   RES=$?   RES=$?
141   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
142   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
143   then   then
144   case "${i}" in   case "${i}" in
145   "1") run_install_auto ;;   "1") run_install_auto ;;
146           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
147   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
148   esac   esac
149   fi   fi
# Line 152  dialog_hardware_detection() Line 154  dialog_hardware_detection()
154   local i   local i
155   local hwtmp   local hwtmp
156    
157   if [ -x $(which mktemp &> /dev/null) ]   if [ -x $(type -P mktemp) ]
158   then   then
159   hwtmp="$(mktemp)"   hwtmp="$(mktemp)"
160   else   else
161   hwtmp="/tmp/hwtmp.sh"   hwtmp="/tmp/hwtmp.sh"
162   fi   fi
163    
164   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
165    
166   echo "dialog \\"  > ${hwtmp}   echo "dialog \\"  > ${hwtmp}
167   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
# Line 169  dialog_hardware_detection() Line 171  dialog_hardware_detection()
171   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
172   echo " Festplatten:\n \\" >> ${hwtmp}   echo " Festplatten:\n \\" >> ${hwtmp}
173    
174   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
175   then   then
176   for i in ${scsidisks}   for i in ${ALL_DISKS}
177   do   do
178   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
179   done   done
180   fi   fi
181    
182   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
183   then   then
184   for i in ${idedisks}   echo " \n \\" >> ${hwtmp}
185     echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
186     for i in ${ALL_CDROMS}
187   do   do
188   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
189   done   done
190   fi   fi
191    
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
  fi  
   
192   # other devices   # other devices
193   run_hardware_detection   run_hardware_detection
194   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
# Line 262  dialog_setup_hdd_partitions_manuell() Line 251  dialog_setup_hdd_partitions_manuell()
251   fi   fi
252  }  }
253    
254  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
255  {  {
256   local i   local i
257    
# Line 294  dialog_setup_hdd_partitions_manuell_flas Line 283  dialog_setup_hdd_partitions_manuell_flas
283   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
284   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
285   then   then
286   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
287   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
288     setup_hdd_partitions_auto
289   fi   fi
290   fi   fi
291  }  }
292    
293  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
294  {  {
295   local i   local bootdev
296    
297   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
298     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
299     # remove the boot device from ALL_DISKS if it was an usbstick
300     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
301   then   then
302   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
303   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
304   fi   fi
305     export ALL_CDROMS="$(get_hwinfo cdrom)"
306  }  }
307    
308  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 427  dialog_main() Line 393  dialog_main()
393   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
394   then   then
395   case ${METHOD} in   case ${METHOD} in
396           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
397   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
398   "3") install_do_reboot ;;   "3") install_do_reboot ;;
399   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 501  hdd_size_below_256mb() Line 467  hdd_size_below_256mb()
467   local hdd="$1"   local hdd="$1"
468   local size   local size
469   local retval   local retval
470   [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"   [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
471    
472   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
473   if [[ ${size} -le 257000000 ]]   if [[ ${size} -le 257000000 ]]
# Line 530  setup_hdd_partitions_auto() Line 496  setup_hdd_partitions_auto()
496   fi   fi
497    
498   ## delete disk   ## delete disk
499   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
500    
501   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
502   then   then
# Line 578  EOF Line 544  EOF
544    
545  setup_hdd_partitions_manuell()  setup_hdd_partitions_manuell()
546  {  {
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
 {  
547   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
548    
549   ## hdds partitionieren manuell   ## hdds partitionieren manuell
550   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
551  }  }
552    
553  setup_hdd_format()  setup_hdd_format()
554  {  {
555   mkswap ${SWAPHDD} || die   mke2fs -j -q ${ROOTHDD} || dialog_die
  mke2fs -j -q ${BOOTHDD} || die  
  mke2fs -j -q ${ROOTHDD} || die  
 }  
   
 setup_hdd_format_flash()  
 {  
  mke2fs -j -q ${ROOTHDD} || die  
556  }  }
557    
558  install_mount_rootfs()  install_mount_rootfs()
559  {  {
560   swapon ${SWAPHDD} || die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
561   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
562   install -d ${INSTALLPATH}/boot || die   cd ${INSTALLROOT} || dialog_die
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
563  }  }
564    
565  install_system_image()  install_system_image()
566  {  {
567   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
568  }  }
569    
570  install_bootsector_chroot()  install_bootsector_chroot()
571  {  {
572   local my_roothdd   local my_roothdd
573   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
574   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
575    
576   # check for grub2   # check for grub2
577   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
578   then   then
579   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
580   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
581   then   then
582   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
583   fi   fi
584    
585   # set kernelopts   # set kernelopts
586   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
587   then   then
588   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
589   else   else
590   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
591   fi   fi
592   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
593   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
594   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
595   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
596    
597   # grub-legacy   # grub-legacy
598   else   else
599   ### grubconf schreiben   ### grubconf schreiben
600   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
601    
602   #for alx only   #for alx only
603   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
604   then   then
605   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
606   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
607   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
608   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
609   fi   fi
# Line 680  install_bootsector_chroot() Line 620  install_bootsector_chroot()
620   my_roothdd="${ROOTHDD}"   my_roothdd="${ROOTHDD}"
621   fi   fi
622    
623   : > ${grubconf} || die   : > ${grubconf} || dialog_die
624   echo "default 0" >> ${grubconf} || die   echo "default 0" >> ${grubconf} || dialog_die
625   echo "timeout 3" >> ${grubconf} || die   echo "timeout 3" >> ${grubconf} || dialog_die
626   # using current root password   # using current root password
627   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
628    
629   echo  >> ${grubconf} || die   echo  >> ${grubconf} || dialog_die
630   echo "# normal boot" >> ${grubconf} || die   echo "# normal boot" >> ${grubconf} || dialog_die
631   echo "title ${KRNVER}" >> ${grubconf} || die   echo "title ${KRNVER}" >> ${grubconf} || dialog_die
632   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
633   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
634   if is_initrd_supported   if is_initrd_supported
635   then   then
636   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
637   fi   fi
638    
639   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
640   echo "# admin boot" >> ${grubconf} || die   echo "# admin boot" >> ${grubconf} || dialog_die
641   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
642   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
643   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
644   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
645   if is_initrd_supported   if is_initrd_supported
646   then   then
647   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
648   fi   fi
649    
650   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
651   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
652   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
653   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
654   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
655   if is_initrd_supported   if is_initrd_supported
656   then   then
657   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
658   fi   fi
659    
660   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
661   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
662  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
663  root (hd0,0)  root (hd0,0)
664  setup (hd0)  setup (hd0)
# Line 728  exit 0 Line 668  exit 0
668  CHROOTEOF  CHROOTEOF
669   fi   fi
670    
671   ## enters chroot   ## enter chroot
672   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
673   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
674   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
675   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
676   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
677   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
678   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
679   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
680  }  }
681    
682  is_initrd_supported()  is_initrd_supported()
683  {  {
684   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
685   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
686   return 1   return 1
687  }  }
688    
# Line 773  install_initrd_chroot() Line 713  install_initrd_chroot()
713   fi   fi
714    
715   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
716   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
717   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
718    
719   # install an appropriate viafb.conf   # install an appropriate viafb.conf
720   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
721    
722   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
723   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
724    
725   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
726  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
727  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
728  exit 0  exit 0
729  CHROOTEOF  CHROOTEOF
730    
731   ## enters chroot   ## enters chroot
732   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
733   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
734   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
735   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
736   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
737   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
738   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
739   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
740  }  }
741    
742  is_uuid_supported()  is_uuid_supported()
743  {  {
744   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
745   then   then
746   # only detect uuids if supported   # only detect uuids if supported
747   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 820  get_uuid() Line 760  get_uuid()
760   local TYPE   local TYPE
761    
762   local dev="$1"   local dev="$1"
763   [[ -z ${dev} ]] && die "no dev given"   [[ -z ${dev} ]] && dialog_die "no dev given"
764    
765   # check if given device is already an UUID   # check if given device is already an UUID
766   if [[ ${dev/UUID=/}x != ${dev}x ]]   if [[ ${dev/UUID=/}x != ${dev}x ]]
# Line 837  install_system_settings() Line 777  install_system_settings()
777   # schreibe fstab   # schreibe fstab
778   if is_uuid_supported   if is_uuid_supported
779   then   then
780   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
781   else   else
782   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
783   fi   fi
784   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
785   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
786   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
787   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
788    
789   # install network config skeleton   # install network config skeleton
790   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
791    
792   # intel framebufer quirk   # intel framebufer quirk
793   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 859  install_system_settings() Line 797  install_system_settings()
797   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
798   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
799   then   then
800   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
801   fi   fi
802   fi   fi
803   fi   fi
804  }  }
805    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
806  install_umount_rootfs()  install_umount_rootfs()
807  {  {
808   cd /   cd /
809   umount ${INSTALLPATH}/boot || die   umount ${INSTALLROOT}/boot || dialog_die
810   umount ${INSTALLPATH} || die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
811  }  }
812    
813  install_do_reboot()  install_do_reboot()
# Line 923  run_install_normal() Line 841  run_install_normal()
841   dialog_install_successful   dialog_install_successful
842  }  }
843    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
844  run_install_auto()  run_install_auto()
845  {  {
846   dialog_hardware_detection   dialog_hardware_detection
847    
848   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
849   dialog_setup_hdd_format   dialog_setup_hdd_format
850   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
851   install_mount_rootfs_flash   install_mount_rootfs
852   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
853    
854   dialog_install_settings   dialog_install_settings
855   sleep 1   sleep 1
856   install_system_settings_flash   install_system_settings
857   install_initrd_chroot   install_initrd_chroot
858    
859   dialog_install_bootsector   dialog_install_bootsector
860   install_bootsector_chroot   install_bootsector_chroot
861    
862   install_umount_rootfs_flash   install_umount_rootfs
863   dialog_install_successful   dialog_install_successful
864  }  }
865    

Legend:
Removed from v.2323  
changed lines
  Added in v.2404